#!/usr/local/bin/perl

use Switch;

$run = True;
%dogs = ();

while($run eq True)
{

	@unique = keys %dogs;
	
	print "------------------------\n";
	print "------------------------\n";
	print "Letezo kutyak: @unique\n";
	print "----------Menu----------\n";
	
	print "1) Kutya letrehozasa\n";
	print "2) Kutya allapotanak lekerdezese\n";
	print "3) Kutya megetetese\n";
	print "4) Kutya parbaj\n";
	print "minden mas) Kilepes\n";				
			
	print "Valasztas: ";
	$inp = <STDIN>;
	chomp($inp);
		
	switch ($inp) 
	{
		case 1 
		{
			print "A kutya neve legyen: ";
			$name = <STDIN>;
			chomp($name);	
			$dogs{$name} = Dog->Create($name);
		}
		case 2 
		{
			print "A kutya neve legyen: ";
			$name = <STDIN>;
			chomp($name);

			## kivetelkezeles #####################			
     		
     		eval 
     		{
       			print "------------------------\n";			
				print $dogs{$name}->State();
				
     		};
     		
     		if ($@) 
     		{
		  		print "Nincs ilyen nevu kutya!\n";
			}
			
			#######################################
		}
		case 3 
		{
			print "A kutya neve legyen: ";
			$name = <STDIN>;
			chomp($name);
			
			print "Mit egyen a kutya: ";
			$food = <STDIN>;
			chomp($food);
						
			eval 
     		{
       			print "------------------------\n";			
				print $dogs{$name}->Feed($food);
				
     		};
     		
     		if ($@) 
     		{
		  		print "Nincs ilyen nevu kutya!\n";
			}
		}
		case 4 
		{
			print "A valasztott kutyam legyen: ";
			$name1 = <STDIN>;
			chomp($name1);
			
			print "Az masik kutya neve legyen: ";
			$name2 = <STDIN>;
			chomp($name2);
			
			
			$isKey = False;
			foreach  $p (@unique)
			{
				if($p eq $name2) { $isKey = True; }
			}
			
			eval 
     		{
     			if($isKey ne True || $name1 eq $name2)
     			{
     				die "";     				     				     				
     			}
     			else
     			{
	       			print "------------------------\n";		
					print $dogs{$name1}->Fight( $dogs{$name2} );     				
     			}     							
     		};
     		
     		if ($@) 
     		{
		  		print "Hiba a nevek megadasanal!\n";
			}	
		}
		else 
		{
			$run = False;		
		}	
	}
}

################### DOG OSZTALY #####################################################

package Dog;

# konstruktor # mindig osztaly metoduskent hivjuk
sub Create
{
    my ($type,$name) = @_;
    
    $nm = "Anonim kutya";
    $nm = $name if defined($name);
    
    my $self = { hung, 5, agr, 5, name, $nm};
    bless $self, $type;
    return $self;
}

# vissza adja a kutya allapotat
sub State()
{
    my ($self) = @_;
    
    return "$self->{name}-> ehsegem: $self->{hung}, idegessegem: $self->{agr}\n";   
}

# vissza adja a kutya idegesseget
sub Agr() 
{
    my ($self) = @_;
    return $self->{agr};
}

# kutya idegessegenek modositasa
sub SetAgr() 
{
    my ($self, $amount) = @_;
    $sum = $self->{agr} + $amount;
    
    if( $sum > 10 ) { $self->{agr} = 10; }
    elsif( $sum < 0 ) { $self->{agr} = 0; }
    else { $self->{agr} = $sum; }    
}

# vissza adja a kutya ehseget
sub Hung() 
{
    my ($self) = @_;
    return $self->{hung};
}

# kutya ehsegenek modositasa
sub SetHung() 
{
    my ($self, $amount) = @_;
    $sum = $self->{hung} + $amount;
    
    if( $sum > 10 ) { $self->{hung} = 10; }
    elsif( $sum < 0 ) { $self->{hung} = 0; }
    else { $self->{hung} = $sum; }    
}

# kutya neve
sub Name() 
{
    my ($self) = @_;
    return $self->{name};
}

# kutya etetese
sub Feed()
{
    my ($self) = shift;
    my $food = shift;
    $message = "";
    
    if($food eq "")
    {
		$self->SetAgr(1);
        $message = "$self->{name}-> etel: $food - ebbol nem lakok jol!\n";
    }	    
    elsif($food eq "macska")
    {
		$self->SetHung(-2);
		$self->SetAgr(1);
	
		$message = "$self->{name}-> etel: $food - jollaktam, csak felidegesitett!\n"
    }
    else
    {    
		$self->SetHung(-1);
	
		$message = "$self->{name}-> etel: $food - legalabb valami!\n";
    }
    
    return $message;
}

# kutya verekedes
sub Fight()
{
    my ($self,$other) = @_;
    $message = "";
    
    $other_agr = "0";
    $other_agr = $other->{agr} if defined($other);
    if($other_agr eq 0) 
    { 
    	return "Nem volt harc!\n";
    }
    
    $message = "$self->{name} vs. $other->{name}\n";
    
    if($self->{agr} < $other_agr)
    {
		$message = "$message$self->{name}-> inkabb elkullogok!\n";	
		
		$self->SetAgr(-2);		
		$self->SetHung(1);
    }
    else
    {	
		$message = "$message$self->{name}-> elzavartam a kutyat!\n";
			    
		$self->SetAgr(-2);		
		$self->SetHung(2);
    }
    
    return $message;
}
			      